{$V-}
uses Crt;
const ESC=#27; SPACE=#32; LEFT=#75; RIGHT=#77; F1=#59;
var Ch:char;
    Beep: boolean;

procedure Draw (x,y:integer;mode:boolean);
var sprite:array [1..2] of string [3];
    i:integer;
begin
 sprite[1]:='/|\';
 sprite[2]:='---';
 for i:=y to y+1 do begin
  gotoxy (x,i);
  if mode then write (sprite[i-y+1])
  else write (' ':3);
 end;
 gotoxy (x+1,y+1);
end;

procedure Draw2 (x,y:integer;mode:boolean);
begin
 gotoxy (x,y);
 if mode then write ('-=-')
 else write (' ':3);
 gotoxy (x+1,y);
end;

procedure Border (x1,y1,x2,y2:integer);
var i:integer;
begin
 gotoxy (x1,y1);
 write ('');
 for i:=x1+1 to x2-1  do write ('');
 write ('');
 for i:=y1+1 to y2-1 do begin
  gotoxy (x1,i);
  write ('');
  gotoxy (x2,i);
  write ('');
 end;
 gotoxy (x1,y2);
 write ('');
 for i:=x1+1 to x2-1  do write ('');
 write ('');
end;

procedure Status (n:integer; s:string);
begin
 textcolor (Cyan);
 gotoxy (1,n); write (' ':79);
 gotoxy (2,n); write (s);
 textcolor (White);
end;

procedure Play (Freq,Del:integer);
begin
 if Beep then Sound (Freq);
 Delay (Del);
 if Beep then NoSound;
end;

procedure Start;
begin
 Border (16,9,65,21);
 window (17,10,64,20);
 clrscr;
 writeln ('  - ⥩ ! ᠭ  ᪠');
 writeln ('   䨣   ப ଠ⨪.');
 writeln ('      ࠢ,  -');
 writeln ('  . ᫨ ९ 冷,  F1 - ');
 writeln (' ⪫祭 㪠.     ⮬ ,');
 writeln (' ᫨   ࠧ  F1. ');
 writeln ('  室    ESCAPE, ⮬ ENTER.');
 writeln (' ----------------------------------------------');
 writeln ('  ENTER  砫...');
 readln;
 window (1,1,80,25);
 clrscr;
end;

procedure Bomb (cx,cy:integer);
var i:integer;
begin
 for i:=1 to 70 do begin
  gotoxy (cx,cy);
  if i mod 2 =0 then write ('\|/')
  else write ('/|\');
  Play(10*i,10);
 end;
end;

procedure EndOfGame (Balls:integer);
begin
 textcolor (yellow); textbackground (blue);
 Border (19,9,61,21);
 window (20,10,60,20);
 clrscr;
 writeln ('  祭');
 writeln (' ᫮ 窮=',Balls);
 writeln ('  ENTER  室...');
 readln;
 textmode (CO80);
 halt;
end;

procedure Print (Lives,Balls,Shots:integer);
begin
 gotoxy (40,1);
 write (':',Lives:5);
 gotoxy (55,1);
 write ('窨:',Balls:5);
 gotoxy (69,1);
 write ('㫨:',Shots:5);
end;

var lives,i,lx,ly,x,y,cx,cy,ix,iy,goal,dx:integer;
    Line,Line2:boolean;
    Balls,Shots:longint;

begin
 TextMode (CO80);
 Start;
 Status (1,'. (C) 祩-, 2000');
 x:=38; y:=24; lx:=x+1; ly:=y-1; line:=false; line2:=false;
 cy:=2; cx:=1; goal:=0; dx:=1; Balls:=0; Shots:=10;
 lives:=3;
 Print (Lives,Balls,Shots);
 Beep:= true;
 repeat {᭮ 横   Esc}
  Draw (x,y,true);
  repeat {      뢮 㫥}
   { 襩 㫨:}
   if line=true then begin
    gotoxy (lx,ly); textcolor (red);
    write ('');    textcolor (white);
    gotoxy (x+1,y+1);
    Play (20,18);
    gotoxy (lx,ly);
    write (' ');
    ly:=ly-1;
    if ly<2 then begin { ⥫}
     if (lx>=cx) and (lx<=cx+2) then begin {}
      Bomb (cx,cy);
      if (lx=cx+1) then Balls:=Balls+1
      else Balls:=Balls+1;
      Shots:=Shots+5;
      Print (Lives,Balls,Shots);
     end;
     line:=false;
    end;
   end
   else Delay (18);
   { 襭:}
   Draw2 (cx,cy,true);
   delay (25);
   Draw2 (cx,cy,false);
   cx:=cx+dx;
   if (cx>77) or (cx<2) or (lx>=cx) and (lx<=cx+2) and (line=true) then dx:=-dx;
   gotoxy (cx,cy); textcolor (yellow);
   i:=Random (10);
   { 㫨  襭:}
   if line2=true then begin { 㦥 ५  }
    gotoxy (ix,iy); textcolor (green);
    write ('');    textcolor (white);
    gotoxy (cx+1,cy+1);
    Play (100,18);
    gotoxy (ix,iy);
    write (' ');
    iy:=iy+1;
    if iy>22 then begin {᫨   ⥫  }
     if (ix>=x) and (ix<=x+2) then begin {  }
      Bomb (x,y);
      lives:=lives-1;
      if lives=0 then begin
       EndOfGame(Balls);
      end;
      Print (Lives,Balls,Shots);
     end;
     line2:=false;
    end;
   end
   else Delay (18);
   if (i=0) and (line2=false) then begin {砫  ५}
    line2:=true;
    ix:=cx+1;
    iy:=2;
   end
  until keypressed;
  Ch:=UpCase(ReadKey);
  case Ch of
   SPACE: begin
    if (Shots>0) and (Line=false) then begin
     Line:=true;
     gotoxy (x+1,y-1);
     lx:=x+1; ly:=y-1;
     write ('');
     if Shots>0 then Shots:=Shots-1;
     Print (Lives,Balls,Shots);
    end
    else if (Shots=0) and (Line=false) then begin
     EndOfGame (Balls);
    end;
   end;
   #0: begin
    Ch:=ReadKey;
    Draw (x,y,false);
    case Ch of
     F1:    Beep:= not Beep;
     LEFT:  if x>2 then x:=x-1;
     RIGHT: if x<77 then x:=x+1;
    end;
   end;
  end;
 until Ch=ESC;
 EndOfGame (Balls);
end.
